<template>
    <v-chart ref="echart" :options="chart_options" autoresize></v-chart>
</template>

<script>
import chart_colors from "./chart_colors";

export default {
    name: "TopBarChart",
    props: {
        chart_data: Array
    },
    watch: {
        chart_data(data){
            if(Array.isArray(this.chart_data) && this.chart_data.length){
                this.setChartData(this.chart_data);
            }
        }
    },
    data(){
        return {
            chart_options: {
                grid: {
                    top: '10%',
                    left: '10%',
                    right: '10%',
                    width: 'auto',
                    height: '80%',
                    containLabel: true,
                },
				tooltip: {
					show: true,
					trigger: 'item',
					enterable: true,
					backgroundColor: '#ffffff',
					textStyle: {
						color: '#346be8',
						fontFamily: 'Geometria',
						fontSize: 14,
						lineHeight: 20,
						fontWeight: 'bold',
					},
					padding: [5, 8],
					extraCssText: 'border-radius: 5px;filter: drop-shadow(0px 5px 5px rgba(120,120,120,0.25));',
					formatter: function (params){
						console.log(params);
						return '$' + Number.parseFloat(params.value[1]).toFixed(2);
					},
					position: 'top',
					axisPointer: {
						type: 'line',
						snap: false,
						lineStyle: {
							color: '#eeecf1',
							width: 2,
						}
					},
				},
                xAxis: {
                    type: 'category',
                    axisLine: {
                        show: false,
                    },
                    axisTick: {
                        show: false,
                    },
                    axisLabel: {
                        color: '#aab2b7',
                        interval: 0,
						rotate: -30,
						margin: 10,
						align: 'center',
						verticalAlign: 'top',
                    }
                },
                yAxis: {
                    type: 'value',
                    axisLine: {
                        show: false,
                    },
                    axisTick: {
                        show: false,
                    },
                    axisLabel: {
                        formatter: (value) => {
                            return Number.parseInt(value) + '$';
                        },
                        color: '#aab2b7',
                    }
                },
                series: [
                    {
                        name: 'chart',
                        type: 'bar',
                        barWidth: 15,
                        itemStyle: {
                            barBorderRadius: [15, 15, 0, 0],
                            color: {
                                type: 'linear',
                                x: 0.5,
                                y: 0,
                                x2: 0.5,
                                y2: 1,
                                colorStops: [{
                                    offset: 0, color: 'rgb(43, 157, 217)' // color at 100% position
                                }, {
                                    offset: 1, color: 'rgb(82, 91, 211)' // color at 0% position
                                }],
                                global: false // false by default
                            }
                        },
                        data: [
                            {
                                value: 2,
                                name: 'a',
                            },
                            {
                                value: 2,
                                name: 'b',
                            },
                            {
                                value: 2,
                                name: 'c',
                            },
                            {
                                value: 1,
                                name: '',
                                itemStyle: {
                                    color: '#f9f9f9'
                                }
                            },
                        ]
                    },
                ],
                color: chart_colors.default_gradients
            }
        }
    },
    methods: {
        setChartData(data){
            this.chart_options.series[0].data = data;
        }
    },
    mounted() {
        if(Array.isArray(this.chart_data) && this.chart_data.length){
            this.setChartData(this.chart_data);
        }
    }
}
</script>

<style scoped>
.echarts {
    width: 100%;
    height: 300px;
}
</style>
